larg = 512      ;largeur de pi/2...

;Entres:  ds:si=offset des points a rotationner
;          es:di=adresse de la pose des points rotationns
;          cx=nb de points  rotationner
Mk_Rotations:
        push    esi      ;on sauve l'offset parce qu'on va calculer avant
        push    edi
        push    ecx
        mov     esi,offset tbsin
        mov     eax,Theta
        add     eax,eax
        add     esi,eax   ;si pointe sur sin(Theta)
        mov     edi,offset tbsin
        mov     eax,Phi
        add     eax,eax
        add     edi,eax   ;di pointe sur sin(Phi)
        mov     ebp,offset tbsin
        xor     eax,eax
        mov     eax,Psi
        add     eax,eax
        add     ebp,eax   ;bp pointe sur sin(Psi)
        ;1re colonne de la matrice
        ;calcul de sin(Theta)*sin(Phi)*sin(Psi)+cos(Theta)*cos(Psi)
        mov     ax,ds:[esi] ;ax=sin(Theta)
        mov     cx,ds:[edi] ;cx=sin(Phi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,15  ;dx contient sin(Theta)*sin(Phi)
        push    dx      ;on le sauve pour apres...
        mov     ax,dx
        mov     cx,ds:[ebp] ;cx=sin(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        mov     ebx,edx ;on prepare ebx pour l'addition
        mov     ax,ds:[esi+larg*2]    ;ax=cos(Theta)
        mov     cx,ds:[ebp+larg*2]    ;cx=cos(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        add     ebx,edx
        sar     ebx,16
        mov     w ds:[matrice],bx      ;1er coeff
        ;on calcule sin(Theta)*cos(Phi)
        mov     ax,ds:[esi]         ;ax=sin(Theta)
        mov     cx,ds:[edi+larg*2]    ;cx=cos(Phi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,16
        mov     w ds:[matrice+2],dx    ;2eme coeff
        ;calcul de sin(Theta)*sin(Phi)*cos(Psi)-cos(Theta)*sin(Psi)
        pop     ax      ;on rcupre sin(Theta)*sin(Phi)
        mov     cx,ds:[ebp+larg*2]    ;cx=cos(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        mov     ebx,edx ;on prepare ebx pour l'addition
        mov     ax,ds:[esi+larg*2]    ;ax=cos(Theta)
        mov     cx,ds:[ebp]         ;cx=sin(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sub     ebx,edx
        sar     ebx,16
        mov     w ds:[matrice+4],bx    ;3me coeff
        ;2me colonne de la matrice
        ;calcul de cos(Theta)*sin(Phi)*sin(Psi)-sin(Theta)*cos(Psi)
        mov     ax,ds:[esi+larg*2]    ;ax=cos(Theta)
        mov     cx,ds:[edi]         ;cx=sin(Phi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,15  ;dx contient sin(Theta)*sin(Phi)
        push    dx      ;on le sauve pour apres...
        mov     ax,dx
        mov     cx,ds:[ebp] ;cx=sin(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        mov     ebx,edx ;on prepare ebx pour l'addition
        mov     ax,ds:[esi]         ;ax=sin(Theta)
        mov     cx,ds:[ebp+larg*2]    ;cx=cos(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sub     ebx,edx
        sar     ebx,16
        mov     w ds:[matrice+6],bx      ;4me coeff
        ;on calcule cos(Theta)*cos(Phi)
        mov     ax,ds:[esi+larg*2]    ;ax=cos(Theta)
        mov     cx,ds:[edi+larg*2]    ;cx=cos(Phi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,16
        mov     w ds:[matrice+8],dx    ;5me coeff
        ;calcul de cos(Theta)*sin(Phi)*cos(Psi)+sin(Theta)*sin(Psi)
        pop     ax      ;on rcupre cos(Theta)*sin(Phi)
        mov     cx,ds:[ebp+larg*2]    ;cx=cos(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        mov     ebx,edx ;on prepare ebx pour l'addition
        mov     ax,ds:[esi]         ;ax=sin(Theta)
        mov     cx,ds:[ebp]         ;cx=sin(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        add     ebx,edx
        sar     ebx,16
        mov     w ds:[matrice+10],bx    ;6me coeff
        ;3me colonne de la matrice
        ;calcul de cos(Phi)*sin(Psi)
        mov     ax,ds:[edi+larg*2]    ;ax=cos(Phi)
        mov     cx,ds:[ebp]         ;cx=sin(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,16
        mov     w ds:[matrice+12],dx   ;7me coeff
        ;calcul de -sin(Phi)
        mov     ax,ds:[edi] ;ax=sin(Phi)
        neg     ax
        sar     ax,1
        mov     w ds:[matrice+14],ax   ;8me coeff
        ;calcul de cos(Phi)*cos(Psi)
        mov     ax,ds:[edi+larg*2]    ;ax=cos(Phi)
        mov     cx,ds:[ebp+larg*2]    ;cx=cos(Psi)
        imul    cx
        sal     edx,16
        mov     dx,ax
        sar     edx,16
        mov     w ds:[matrice+16],dx   ;9me et dernier coeff
        ;on va vraiment rotationner.
        mov     esi,offset matrice
        pop     ecx      ;nombre de points  faire tourner
        pop     ebp
        pop     edi
next_pt:
        mov     ax,ds:[edi]      ;x*4
        imul    w ds:[esi]
        mov     ds:[ebp],dx
        mov     ax,ds:[edi]       ;x*4
        imul    w ds:[esi+2]
        mov     ds:[ebp+2],dx
        mov     ax,ds:[edi]       ;x*4
        imul    w ds:[esi+4]
        mov     ds:[ebp+4],dx

        mov     ax,ds:[edi+2]      ;y*4
        imul    w ds:[esi+6]
        add     ds:[ebp],dx
        mov     ax,ds:[edi+2]       ;y*4
        imul    w ds:[esi+8]
        add     ds:[ebp+2],dx
        mov     ax,ds:[edi+2]       ;y*4
        imul    w ds:[esi+10]
        add     ds:[ebp+4],dx

        mov     ax,ds:[edi+4]      ;z*4
        imul    w ds:[esi+12]
        add     ds:[ebp],dx
        mov     ax,ds:[edi+4]       ;z*4
        imul    w ds:[esi+14]
        add     ds:[ebp+2],dx
        mov     ax,ds:[edi+4]       ;z*4
        imul    w ds:[esi+16]
        add     ds:[ebp+4],dx

        add     edi,6
        add     ebp,6
        dec     cx
        jnz     next_pt
        ret
